function [A,b,exactsol]=signalrec(n)

%meta' ampiezza del filtro
h=20;
% diminuire h per avere una matrice meno mal condizionata
gamma=6;
for i=-h:h
    c(h+1+i)=exp(-i^2/(2*gamma^2));
end
%normalizzare i coefficienti di convoluzione
c=c/sum(c);
plot(-h:h,c,'*');
title('Coefficienti di convoluzione');
%creare matrice A
A=zeros(n);
for i=1:n
    for j=1:n
        k=h+1+i-j;
        if (k>0 & k<=2*h+1)
            k
            
            A(i,j)=c(k);
        end
    end
end


% costruire il segnale di input (staircase)
exactsol=zeros(n,1);
for k=1:n
    if (k<50)
        exactsol(k)=0;
    elseif (k<100)
        exactsol(k)=1;
    elseif (k<150)
        exactsol(k)=4;
    else
        exactsol(k)=0;
    end
end
% risposta del sistema
b=A*exactsol;
        